package com.lightinit.hsdataportal.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class RequirementDataExample extends BaseExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public RequirementDataExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDataUsesIsNull() {
            addCriterion("data_uses is null");
            return (Criteria) this;
        }

        public Criteria andDataUsesIsNotNull() {
            addCriterion("data_uses is not null");
            return (Criteria) this;
        }

        public Criteria andDataUsesEqualTo(String value) {
            addCriterion("data_uses =", value, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesNotEqualTo(String value) {
            addCriterion("data_uses <>", value, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesGreaterThan(String value) {
            addCriterion("data_uses >", value, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesGreaterThanOrEqualTo(String value) {
            addCriterion("data_uses >=", value, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesLessThan(String value) {
            addCriterion("data_uses <", value, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesLessThanOrEqualTo(String value) {
            addCriterion("data_uses <=", value, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesLike(String value) {
            addCriterion("data_uses like", value, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesNotLike(String value) {
            addCriterion("data_uses not like", value, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesIn(List<String> values) {
            addCriterion("data_uses in", values, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesNotIn(List<String> values) {
            addCriterion("data_uses not in", values, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesBetween(String value1, String value2) {
            addCriterion("data_uses between", value1, value2, "dataUses");
            return (Criteria) this;
        }

        public Criteria andDataUsesNotBetween(String value1, String value2) {
            addCriterion("data_uses not between", value1, value2, "dataUses");
            return (Criteria) this;
        }

        public Criteria andSectorIdIsNull() {
            addCriterion("sector_id is null");
            return (Criteria) this;
        }

        public Criteria andSectorIdIsNotNull() {
            addCriterion("sector_id is not null");
            return (Criteria) this;
        }

        public Criteria andSectorIdEqualTo(Long value) {
            addCriterion("sector_id =", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdNotEqualTo(Long value) {
            addCriterion("sector_id <>", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdGreaterThan(Long value) {
            addCriterion("sector_id >", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdGreaterThanOrEqualTo(Long value) {
            addCriterion("sector_id >=", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdLessThan(Long value) {
            addCriterion("sector_id <", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdLessThanOrEqualTo(Long value) {
            addCriterion("sector_id <=", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdIn(List<Long> values) {
            addCriterion("sector_id in", values, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdNotIn(List<Long> values) {
            addCriterion("sector_id not in", values, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdBetween(Long value1, Long value2) {
            addCriterion("sector_id between", value1, value2, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdNotBetween(Long value1, Long value2) {
            addCriterion("sector_id not between", value1, value2, "sectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdIsNull() {
            addCriterion("rqrmnt_sector_id is null");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdIsNotNull() {
            addCriterion("rqrmnt_sector_id is not null");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdEqualTo(Long value) {
            addCriterion("rqrmnt_sector_id =", value, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdNotEqualTo(Long value) {
            addCriterion("rqrmnt_sector_id <>", value, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdGreaterThan(Long value) {
            addCriterion("rqrmnt_sector_id >", value, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdGreaterThanOrEqualTo(Long value) {
            addCriterion("rqrmnt_sector_id >=", value, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdLessThan(Long value) {
            addCriterion("rqrmnt_sector_id <", value, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdLessThanOrEqualTo(Long value) {
            addCriterion("rqrmnt_sector_id <=", value, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdIn(List<Long> values) {
            addCriterion("rqrmnt_sector_id in", values, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdNotIn(List<Long> values) {
            addCriterion("rqrmnt_sector_id not in", values, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdBetween(Long value1, Long value2) {
            addCriterion("rqrmnt_sector_id between", value1, value2, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andRqrmntSectorIdNotBetween(Long value1, Long value2) {
            addCriterion("rqrmnt_sector_id not between", value1, value2, "rqrmntSectorId");
            return (Criteria) this;
        }

        public Criteria andDataAddModeIsNull() {
            addCriterion("data_add_mode is null");
            return (Criteria) this;
        }

        public Criteria andDataAddModeIsNotNull() {
            addCriterion("data_add_mode is not null");
            return (Criteria) this;
        }

        public Criteria andDataAddModeEqualTo(String value) {
            addCriterion("data_add_mode =", value, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeNotEqualTo(String value) {
            addCriterion("data_add_mode <>", value, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeGreaterThan(String value) {
            addCriterion("data_add_mode >", value, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeGreaterThanOrEqualTo(String value) {
            addCriterion("data_add_mode >=", value, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeLessThan(String value) {
            addCriterion("data_add_mode <", value, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeLessThanOrEqualTo(String value) {
            addCriterion("data_add_mode <=", value, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeLike(String value) {
            addCriterion("data_add_mode like", value, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeNotLike(String value) {
            addCriterion("data_add_mode not like", value, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeIn(List<String> values) {
            addCriterion("data_add_mode in", values, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeNotIn(List<String> values) {
            addCriterion("data_add_mode not in", values, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeBetween(String value1, String value2) {
            addCriterion("data_add_mode between", value1, value2, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andDataAddModeNotBetween(String value1, String value2) {
            addCriterion("data_add_mode not between", value1, value2, "dataAddMode");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtIsNull() {
            addCriterion("feedback_at is null");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtIsNotNull() {
            addCriterion("feedback_at is not null");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtEqualTo(Date value) {
            addCriterion("feedback_at =", value, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtNotEqualTo(Date value) {
            addCriterion("feedback_at <>", value, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtGreaterThan(Date value) {
            addCriterion("feedback_at >", value, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtGreaterThanOrEqualTo(Date value) {
            addCriterion("feedback_at >=", value, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtLessThan(Date value) {
            addCriterion("feedback_at <", value, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtLessThanOrEqualTo(Date value) {
            addCriterion("feedback_at <=", value, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtIn(List<Date> values) {
            addCriterion("feedback_at in", values, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtNotIn(List<Date> values) {
            addCriterion("feedback_at not in", values, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtBetween(Date value1, Date value2) {
            addCriterion("feedback_at between", value1, value2, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackAtNotBetween(Date value1, Date value2) {
            addCriterion("feedback_at not between", value1, value2, "feedbackAt");
            return (Criteria) this;
        }

        public Criteria andFeedbackByIsNull() {
            addCriterion("feedback_by is null");
            return (Criteria) this;
        }

        public Criteria andFeedbackByIsNotNull() {
            addCriterion("feedback_by is not null");
            return (Criteria) this;
        }

        public Criteria andFeedbackByEqualTo(Long value) {
            addCriterion("feedback_by =", value, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackByNotEqualTo(Long value) {
            addCriterion("feedback_by <>", value, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackByGreaterThan(Long value) {
            addCriterion("feedback_by >", value, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackByGreaterThanOrEqualTo(Long value) {
            addCriterion("feedback_by >=", value, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackByLessThan(Long value) {
            addCriterion("feedback_by <", value, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackByLessThanOrEqualTo(Long value) {
            addCriterion("feedback_by <=", value, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackByIn(List<Long> values) {
            addCriterion("feedback_by in", values, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackByNotIn(List<Long> values) {
            addCriterion("feedback_by not in", values, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackByBetween(Long value1, Long value2) {
            addCriterion("feedback_by between", value1, value2, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackByNotBetween(Long value1, Long value2) {
            addCriterion("feedback_by not between", value1, value2, "feedbackBy");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultIsNull() {
            addCriterion("feedback_result is null");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultIsNotNull() {
            addCriterion("feedback_result is not null");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultEqualTo(String value) {
            addCriterion("feedback_result =", value, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultNotEqualTo(String value) {
            addCriterion("feedback_result <>", value, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultGreaterThan(String value) {
            addCriterion("feedback_result >", value, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultGreaterThanOrEqualTo(String value) {
            addCriterion("feedback_result >=", value, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultLessThan(String value) {
            addCriterion("feedback_result <", value, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultLessThanOrEqualTo(String value) {
            addCriterion("feedback_result <=", value, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultLike(String value) {
            addCriterion("feedback_result like", value, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultNotLike(String value) {
            addCriterion("feedback_result not like", value, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultIn(List<String> values) {
            addCriterion("feedback_result in", values, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultNotIn(List<String> values) {
            addCriterion("feedback_result not in", values, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultBetween(String value1, String value2) {
            addCriterion("feedback_result between", value1, value2, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackResultNotBetween(String value1, String value2) {
            addCriterion("feedback_result not between", value1, value2, "feedbackResult");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescIsNull() {
            addCriterion("feedback_desc is null");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescIsNotNull() {
            addCriterion("feedback_desc is not null");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescEqualTo(String value) {
            addCriterion("feedback_desc =", value, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescNotEqualTo(String value) {
            addCriterion("feedback_desc <>", value, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescGreaterThan(String value) {
            addCriterion("feedback_desc >", value, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescGreaterThanOrEqualTo(String value) {
            addCriterion("feedback_desc >=", value, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescLessThan(String value) {
            addCriterion("feedback_desc <", value, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescLessThanOrEqualTo(String value) {
            addCriterion("feedback_desc <=", value, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescLike(String value) {
            addCriterion("feedback_desc like", value, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescNotLike(String value) {
            addCriterion("feedback_desc not like", value, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescIn(List<String> values) {
            addCriterion("feedback_desc in", values, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescNotIn(List<String> values) {
            addCriterion("feedback_desc not in", values, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescBetween(String value1, String value2) {
            addCriterion("feedback_desc between", value1, value2, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andFeedbackDescNotBetween(String value1, String value2) {
            addCriterion("feedback_desc not between", value1, value2, "feedbackDesc");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlIsNull() {
            addCriterion("data_publish_url is null");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlIsNotNull() {
            addCriterion("data_publish_url is not null");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlEqualTo(String value) {
            addCriterion("data_publish_url =", value, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlNotEqualTo(String value) {
            addCriterion("data_publish_url <>", value, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlGreaterThan(String value) {
            addCriterion("data_publish_url >", value, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlGreaterThanOrEqualTo(String value) {
            addCriterion("data_publish_url >=", value, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlLessThan(String value) {
            addCriterion("data_publish_url <", value, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlLessThanOrEqualTo(String value) {
            addCriterion("data_publish_url <=", value, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlLike(String value) {
            addCriterion("data_publish_url like", value, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlNotLike(String value) {
            addCriterion("data_publish_url not like", value, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlIn(List<String> values) {
            addCriterion("data_publish_url in", values, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlNotIn(List<String> values) {
            addCriterion("data_publish_url not in", values, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlBetween(String value1, String value2) {
            addCriterion("data_publish_url between", value1, value2, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andDataPublishUrlNotBetween(String value1, String value2) {
            addCriterion("data_publish_url not between", value1, value2, "dataPublishUrl");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(Long value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(Long value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(Long value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(Long value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(Long value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(Long value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<Long> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<Long> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(Long value1, Long value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(Long value1, Long value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(Long value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(Long value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(Long value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(Long value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(Long value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(Long value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<Long> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<Long> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(Long value1, Long value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(Long value1, Long value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}